; Panasonic end of "Panana"
; Burn to an EPROM of minimum 256 bytes :)
;
; 21.09.2014: More delays, seems to help. Jump to BASIC upon errors or nostart.
; 01.09.2014: I friggin' deleted the source and had to retype it from disasm

	cpu 6800
	* = $d800

CARRIER	equ	$0ff9
PREV	equ	$0ffa
STRT	equ	$0ffb
LEN	equ	$0ffc
DEST	equ	$0ffe

	jmp	nakki
nakki	sei
	ldaa	#'P'
	staa	$c11f
	ldaa	#0
	staa	CARRIER

; Handshake
p1	ldaa	$8000
	cmpa	#$ff
	nop
	nop
	bne	p1
p2	ldaa	$8000
	cmpa	#$42
	nop
	nop
	bne	p2
p3	ldaa	$8000
	cmpa	#$43
	nop
	nop
	bne	p3

	staa	PREV

	ldaa	#'T'
	staa	$c11f

; Flags, length, address
	jsr	decode
	staa	STRT

	jsr	decode
	staa	LEN
	jsr	decode
	staa	LEN+1

	jsr	decode
	staa	DEST
	jsr	decode
	staa	DEST+1

	ldx	LEN
	dex
	stx	LEN
	ldx	DEST
	clrb

; Transfer main data
main	jsr	decode
	staa	,x
	addb	,x
	inx

	ldaa	LEN+1
	suba	#1
	staa	LEN+1
	ldaa	LEN
	sbca	#0
	bmi	datadun
	staa	LEN
	jmp	main

; Checksum
datadun	ldaa	#'C'
	staa	$c11f
	jsr	decode

	stab	LEN
	cmpa	LEN
	bne	errori

; Alles gut
	nop
	nop
	ldaa	$8000
	cli
	ldaa	#$82
	staa	$c11f
	ldaa	STRT
	beq	nostart

	ldaa	#$7e
	staa	DEST-1
	jmp	DEST-1

nostart	jmp	$a000 ; Beisik

; Not ok
errori	cli
	ldaa	#'E'
	staa	$c11f
	jmp	$a000 ; Beisik

; Decode a byte from the stream
decode	ldaa	$8000
	cmpa	PREV
	nop
	nop
	beq	decode

	staa	$c11f

	cmpa	#$ff ; Escaped byte
	bne	normal

nexti	ldaa	$8000
	cmpa	#$ff
	nop
	nop
	beq	nexti

	cmpa	#$fe
	bne	normal

nexti2	ldaa	$8000
	cmpa	#$fe
	nop
	nop
	beq	nexti2

	staa	PREV
	adda	#$fe

	suba	CARRIER
	inc	CARRIER
	rts

normal	staa	PREV
	suba	CARRIER
	inc	CARRIER
	rts
